#include "InputTerminal.h"

//#include <memory.h>
#define OK 1
#define NG 0

InputTerminal::InputTerminal(unsigned char *input_terminal, unsigned char terminal_num)
{
	unsigned char i;

	err = ITERR_NON;						// G[NA
	
	if (terminal_num < 16){
		Tm_num = terminal_num;
#ifndef TM_PIN_NUM
		Tm_Pin = new unsigned char[terminal_num];
#endif

		for (i = 0; i<Tm_num; i++){
			Tm_Pin[i] = input_terminal[i];
			pinMode(Tm_Pin[i], INPUT_PULLUP);	// ̓vAbvݒ
			//		printf("pin %d:%d:%d\n", i, Tm_Pin[i],input_terminal[i]);

		}
		//	memcopy(Tm_Pin,input_terminal,sizeof(input_terminal));
	}
	else{
		Tm_num = 0;
		err = ITERR_KEYNUM;						// L[ݒ萔I[o[
	}


	keychktim_shortw = IT_KEYCHKTIM_SHORT;
	keychktim_longw = IT_KEYCHKTIM_LONG;
	
	shorton_keydataw = 0;
	longon_keydataw = 0;
	keydat = 0;
	
	return;
}

InputTerminal::~InputTerminal(void)
{

#ifndef TM_PIN_NUM
	delete[] Tm_Pin;
#endif

	return;
}


void InputTerminal::view_pin(void)
{
	unsigned char i;

	Serial.print("pin_num:");
	Serial.println(Tm_num);

	for (i = 0; i < Tm_num; i++){
		Serial.print("pin ");
		Serial.print(i);
		Serial.print(":");
		Serial.println(Tm_Pin[i]);
	}

	return;
}

// L[̓|[gԁiuj쐬
unsigned int InputTerminal::makekeydata(void)
{
	unsigned char i;

	keydat = 0;
	
	for (i = 0; i<Tm_num; i++){
		keydat |= ((!(unsigned int)digitalRead(Tm_Pin[i])) << i);
	}

	return (keydat);
}

void InputTerminal::scan(void)
{

	unsigned int keydatw;              // L[̓f[^iulj
	static unsigned int keydat_lastw;  // L[̓f[^iOlj
	static unsigned char keychkw;       // L[͔苖stO

	keydatw = makekeydata();        // L[̏uԓǂݍ

	if (((shorton_keydataw == 0) && (longon_keydataw == 0) // OL[͏ς
		&& (keydatw == 0) && (keydat_lastw == 0))        // L[̓f[^Ȃ
//		|| (keymode == KEY_RESET)
		) {                       // ZbgĂяo
		keychkw = OK;                                          // L[͔苖
		itm_starttiml = millis();                              // L[͎ԏ񏉊
		// L[͂s܂Ŗ񂱂ŏB
	}
	else {}

	if (keychkw == OK) {
		if (keydatw == keydat_lastw) {               // L[ꒆ
			if ((millis() - itm_starttiml) >= (unsigned long)keychktim_longw) {   // 莞ԁ@ONɔ
				longon_keydataw = keydat_lastw;                    // L[͏m
				keychkw = NG;                                      // L[͕sƂ
			}
		}
		else if (keydatw < keydat_lastw) {           // O񂩂牟ĂL[ = OFFGbW
			// ZOŃAĂL[_Ŕ肷BiOFF^C~OꂽƉ߁j
			if ((millis() - itm_starttiml) >= (unsigned long)keychktim_shortw) {  // Z莞ԁB@ZOFFGbWŔ
				shorton_keydataw = keydat_lastw;                   // ZL[͏m
				keychkw = NG;                                      // L[͕sƂ
				// ɃL[OFFƂȂꍇAcL[݂̂
				// Ĕ肵Ȃ悤ɁASOFF܂ŃL[͔sƂB
			}
			else {}

			itm_starttiml = millis();                              // L[͎ԏ񏉊
		}
		else { // O񂩂牟ĂL[
			// OŃAꂽL[_ăJEg
			itm_starttiml = millis();                              // L[͎ԏ񏉊
		}

	}
	else {
		itm_starttiml = millis();                              // L[͎ԏ񏉊
	}
			
	keydat_lastw = keydatw;          // Olێ
	return;

	return;
}


unsigned int InputTerminal::read(void)
{
	unsigned int ret;
	
	ret = read_s() | read_l();
	
	return(ret);

}


unsigned int InputTerminal::read_s(void)
{
	unsigned int ret;
	
	ret = shorton_keydataw;
	shorton_keydataw = 0;
	
	return(ret);

}

unsigned int InputTerminal::read_l(void)
{
	unsigned int ret;
	
	ret = longon_keydataw;
	longon_keydataw = 0;
	
	return(ret);

}

unsigned char InputTerminal::read_tmnum(void)
{
	return(Tm_num);
}

unsigned char InputTerminal::read_err(void)
{
	return(err);
}


